$(document).ready(function () {
    $("body").off('click').on("click", '.remove', remove);
//    $(".tbody").on("blur", '.rate', autoAddRows);
    $("body").on("change blur", '.qty, .rate, .amount, .discperc, .total', itemCal);
    $("body").on("change blur", '.subtotal, .litemdisc, .cdicsperc, .cdiscamt, .lessoth, .vatperc, .vatamt, .packing, .netamt', mainbCal);
    $("body").on("keyup focus blur", '.total', autoAddRows);
    $("body").on("keyup focus blur change", '.itemcode', GetItemFromCode);
    $("body").on("keyup focus blur change", '.item', showDetail);

    function GetItemFromCode() {
        var $row = $(this).closest("tr");
        var itemcode = $row.find(".itemcode").val();
        $.post('show_item_dtl.php', {itemcode: itemcode}, function (data) {
            if (data != '') {
                $row.find(".item").html(data).trigger("change");
            }
        });
    }

    //getting rate from item
    function showDetail() {
        var tr = $(this).closest("tr");
        var name = tr.find('.item').val();
        $.ajax({
            type: 'GET',
            dataType: 'json',
            url: "get_itemrate_dtl.php",
            data: "name=" + name + "",
            success: function (response) {
                var code = response.code;
//                var rate = response.rate;
                var msp = response.msp;
                var mrp = response.mrp;
                $(tr.find('.itemcode')).val(code);
//                $(tr.find('.rate')).val(rate);
                $(tr.find('.msp')).val(msp);
                $(tr.find('.mrp')).val(mrp);
            },
            error: function (request, textStatus, errorThrown) {
                alert(errorThrown);
            }
        });
    }



    $('#addnew').click(function () {
        AddRows();
    });

    function autoAddRows() {
        var ctr = $('#items').val();
        var tr = $(this).closest("tr");
        var srno = tr.find(".srno").val();
        if (srno == ctr) {
            AddRows();

        }
    }

    function remove() {
        $(this).closest("tr").remove();
    }

    function AddRows() {
        var ctr = $('#items').val();
        var hide_check = "";
        if ($("#del_all").prop("checked")) {
            hide_check = 0;
        } else {
            hide_check = 1;
        }
        var detail = ".fetchpart_" + ctr;
        $.post('debnote_add.php', {ctr: ctr, hide: hide_check}, function (data) {
            $(data).appendTo('.tbody');
            ctr++;
            $('#items').val(ctr);
            $(detail).select2();
        });
    }


    function itemCal() {
        var tr = $(this).closest("tr"),
                qty = tr.find(".qty").val(),
                mrp = tr.find(".mrp").val(),
                rate = tr.find(".rate").val(),
                amount = parseFloat(qty) * parseFloat(rate),
                discperc = tr.find(".discperc").val(),
                discount = discperc * amount / 100,
                total = parseFloat(amount) - parseFloat(discount);

        tr.find(".amount").val(amount);
        tr.find(".discount").val(discount);
        tr.find(".total").val(total);


        var val = 0;
        $(".amount").each(function () {
            if (!isNaN(this.value) && this.value.length != 0) {
                val += parseFloat(this.value);
            }
        });
        $(".subtotal").val(val);

        var val2 = 0;
        $(".discount").each(function () {
            if (!isNaN(this.value) && this.value.length != 0) {
                val2 += parseFloat(this.value);
            }
        });
        $(".litemdisc").val(val2);
        mainbCal();
    }

    function mainbCal() {
        
        var subtot = $(".subtotal").val();
        var litemdisc = $(".litemdisc").val();
        var lessoth = $(".lessoth").val();

        var disc1 = subtot - litemdisc;

        var discperc = $(".cdicsperc").val(),
                cdiscamt = (discperc * disc1) / 100;

        if (isNaN(cdiscamt)) {
            $('.cdiscamt').val("0");
        } else {
            $('.cdiscamt').val(cdiscamt);
        }


        var subtot1 = subtot - litemdisc - cdiscamt - lessoth;

        var vatperc = $(".vatperc").val(),
                vatamt = (vatperc * subtot1) / 100;

        if (isNaN(vatamt)) {
            $('.vatamt').val("0");
        } else {
            $('.vatamt').val(vatamt);
        }


        var pack = $(".packing").val();

        var net = parseFloat(subtot1) + parseFloat(vatamt) + parseFloat(pack);

        if (isNaN(net)) {
            $('.netamt').val("0");
        } else {
            $('.netamt').val(net);
        }
        

    }


});